% lab03_ex_do_undo.m - forward and backward orthogonal DCT-IV transform
clear all;

N=100;                                         % transformation order (matrix size)
x=randn(N,1);                                  % signal to be transformed
k=(0:N-1); n=(0:N-1);                          % indexes of: basis functions, b.f. samples
V = sqrt(2/N)*cos( pi/N * (n'+1/2)*(k+1/2) );  % square transformation matrix
X = V' * x;                                    % forward (direct) transformation
xe = V * X;                                    % backward (inverse) transformation
error = max(abs( x-xe )),                      % test of perfect reconstruction
ortho = sum( V(:,10).*conj(V(:,20))),          % vector orthogonality test, =0?

% #########################################################################
% Supplement - element-by-element orthogonal matrix generation for DCT-IV
% Samples of basis functions are in matrix V columns 
for k=0:N-1
    for n=0:N-1
        V1(n+1,k+1) = sqrt(2/N)*cos( pi/N * (n+1/2)*(k+1/2) );
    end
end  
for k=0:N-1
    V2(:,k+1) = sqrt(2/N)*cos( pi/N * ((0:N-1)'+1/2)*(k+1/2) );
end
error1 = max(max(V-V1))
error2 = max(max(V-V2))
