% lab03_ex_transforms
clear all; close all;

N = 8; % for ortho checking set N=8, for spectrum viewing set N=100

% Orthogonal transform matrices V (basis functions in columns)
k=0:N-1; n=0:N-1;              % k - basis function index, n - b.f. sample index

                               % comment the below two lines after understanding them
IndxMatrix = n'*k,             % outer product of two vectors of indexes --> matrix
CosMatrix = cos( IndxMatrix ), pause   % basis function values for matrix of indexes

k=(0:N-1); n=(0:N-1); nk = [1,N];
V1 = sqrt(2/(N-1)) * cos( pi*n'*k/(N-1));                           % DCT-I
V1(nk,:)=V1(nk,:)/sqrt(2); V1(:,nk)=V1(:,nk)/sqrt(2);               % DCT-I
V2 = sqrt(2/N) * cos( pi*(n+1/2)'*k/N );  V2(:,1)=V2(:,1)/sqrt(2);  % DCT-II
V3 = sqrt(2/N) * cos( pi*n'*(k+1/2)/N );  V3(1,:)=V3(1,:)/sqrt(2);  % DCT-III
V4 = sqrt(2/N) * cos( pi/N *(n+1/2)'*(k+1/2) );                     % DCT-IV
V5 = sqrt(2/(N+1)) * sin(pi*(n+1)'*(k+1)/(N+1));                    % DST
V6 = sqrt(1/N) * ( cos(2*pi/N*n'*k) + sin(2*pi/N*n'*k) );           % Hartley
V7 = sqrt(1/N) * exp(j*2*pi/N *n'*k);  % DFT - only info, real() below for DFT

V = V1;                        % our choice
ortho  = V' * V,               % orthogonality test: 1s on main diag, 0s elsewhere?

for k = 1:N                                        % comment these three lines
    k, stem(real(V(:,k))), title('V(:,k)'); pause  % after seeing the transform
end                                                % basis functions

% Choosing signal to be transformed forward and backward (vertical vector)
N1 = floor(N/2); N2=N-N1; 
x1 = 5*V(:,2) + 10*V(:,7);              % #1: linear superposition of V columns
x2 = [ x1(N); x1(1:N-1) ];              % #2: first signal shifted by one sample 
x3 = sin(2*pi/7*n');                    % #3: pure sine
x4 = [ones(N1,1); -ones(N2,1)];         % #4: rectangular wave
x5 = randn(N,1);                        % #5: random Gaussian noise
% x6 = ...;                             % #6: now your turn
x = x1;                                 % OUR CHOICE
figure; plot(n,real(x),'ro-'); title('x(n)');  % signal plot

% Transformations                       % (.)' means transposition and conjugation
X = V'*x;                               % DIRECT TRANSFORMATION (analysis)
figure; stem(real(X)); title('X(k)');   % plot of transform coefficients

if(0)                                   % possible "spectrum" modification
 X(8) = 0;                              % remove unwanted components
 figure; stem(real(X)); title('Xm(k)'); % plot of modified transform coefficients
end                                     %

xs = V*X;                               % INVERSE TRANSFORMATION (synthesis)
error = max(abs(x-xs)),                 % signal reconstruction error
figure; plot(n,real(x),'ro-',n,real(xs),'b*-'); title('xs(n)'); % synthesized signal
